/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationsCounts type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationsCounts{}

// NotificationsCounts struct for NotificationsCounts
type NotificationsCounts struct {
	Info int32 `json:"info"`
	Warning int32 `json:"warning"`
	Critical int32 `json:"critical"`
}

// NewNotificationsCounts instantiates a new NotificationsCounts object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationsCounts(info int32, warning int32, critical int32) *NotificationsCounts {
	this := NotificationsCounts{}
	this.Info = info
	this.Warning = warning
	this.Critical = critical
	return &this
}

// NewNotificationsCountsWithDefaults instantiates a new NotificationsCounts object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationsCountsWithDefaults() *NotificationsCounts {
	this := NotificationsCounts{}
	return &this
}

// GetInfo returns the Info field value
func (o *NotificationsCounts) GetInfo() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Info
}

// GetInfoOk returns a tuple with the Info field value
// and a boolean to check if the value has been set.
func (o *NotificationsCounts) GetInfoOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Info, true
}

// SetInfo sets field value
func (o *NotificationsCounts) SetInfo(v int32) {
	o.Info = v
}

// GetWarning returns the Warning field value
func (o *NotificationsCounts) GetWarning() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Warning
}

// GetWarningOk returns a tuple with the Warning field value
// and a boolean to check if the value has been set.
func (o *NotificationsCounts) GetWarningOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Warning, true
}

// SetWarning sets field value
func (o *NotificationsCounts) SetWarning(v int32) {
	o.Warning = v
}

// GetCritical returns the Critical field value
func (o *NotificationsCounts) GetCritical() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Critical
}

// GetCriticalOk returns a tuple with the Critical field value
// and a boolean to check if the value has been set.
func (o *NotificationsCounts) GetCriticalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Critical, true
}

// SetCritical sets field value
func (o *NotificationsCounts) SetCritical(v int32) {
	o.Critical = v
}

func (o NotificationsCounts) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationsCounts) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["info"] = o.Info
	toSerialize["warning"] = o.Warning
	toSerialize["critical"] = o.Critical
	return toSerialize, nil
}

type NullableNotificationsCounts struct {
	value *NotificationsCounts
	isSet bool
}

func (v NullableNotificationsCounts) Get() *NotificationsCounts {
	return v.value
}

func (v *NullableNotificationsCounts) Set(val *NotificationsCounts) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationsCounts) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationsCounts) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationsCounts(val *NotificationsCounts) *NullableNotificationsCounts {
	return &NullableNotificationsCounts{value: val, isSet: true}
}

func (v NullableNotificationsCounts) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationsCounts) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


